--
--	PostgreSQL code for phone numbers (US numbers only).
--

load '/usr/local/pgsql/lib/phone_number.so';

--
--	Input and output functions and the type itself:
--

create function us_phone_number_in(opaque)
	returns opaque
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_out(opaque)
	returns opaque
	as '/usr/local/pgsql/lib/phon_number.so'
	language 'c';

create type us_phone_number (
	internallength = 6,
	externallength = variable,
	input = us_phone_number_in,
	output = us_phone_number_out
);

--
--	The boolean tests:
--

create function us_phone_number_lt(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_le(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_gt(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_ge(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_eq(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

create function us_phone_number_ne(us_phone_number, us_phone_number)
	returns bool
	as '/usr/local/pgsql/lib/phone_number.so'
	language 'c';

--
--	Now the operators.  Note how some of the parameters to some
--	of the 'create operator' commands are commented out.  This
--	is because they reference as yet undefined operators, and
--	will be implicitly defined when those are, further down.
--

create operator < (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
--	negator = >=,
	procedure = us_phone_number_lt
);

create operator <= (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
--	negator = >,
	procedure = us_phone_number_le
);

create operator = (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
	commutator = =,
--	negator = <>,
	procedure = us_phone_number_eq
);

create operator >= (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
	negator = <,
	procedure = us_phone_number_ge
);

create operator > (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
	negator = <=,
	procedure = us_phone_number_gt
);

create operator <> (
	leftarg = us_phone_number,
	rightarg = us_phone_number,
	negator = =,
	procedure = us_phone_number_ne
);

--
--	eof
--
